module AppConfig
  @@env_prefix = nil unless defined?(@@env_prefix)
  def self.env_prefix
    @@env_prefix
  end
  def self.env_prefix=(value)
    @@env_prefix = value
  end

  @@config = nil unless defined?(@@config)
  def self.config
    @@config
  end
  def self.config=(value)
    @@config = value
  end

  def self.configure
    @@config ||= {}
    yield @@config
  end

  def self.[](name, default = nil)
    ENV.fetch("#{env_prefix}#{name.to_s.upcase.sub('-','_')}", config.respond_to?(:fetch) ? config.fetch(name.to_s, default) : default)
  end

  def self.method_missing(name, *args, &block)
    if block_given?
      self[name, yield(*args)]
    else
      self[name, args.first]
    end
  end
end
